#!/usr/bin/python
# -*- coding: utf-8
# --------------------------------------------------------
# Usa NLTK HMMs para entrenar un model
# --------------------------------------------------------
# Script: entrena.py
# --------------------------------------------------------
# Ivan Vladimir Meza-Ruiz
# 2009/IIMAS/UNAM
# --------------------------------------------------------



import os.path
import sys
import re
from nltk.tag.hmm import *

def usage():
        print '''
Usage:
        ./entrena voca states filename_train filename_test

voca        Archivo con el vocabulario del modelo
states      Archivo con los estados del modelo
filename_train    Archivo del corpus a entrenar
filename_test    Archivo del corpus a etiquetar
'''

if len(sys.argv)!=5:
    usage()
    exit(1)

fn_corpus  =sys.argv[3]
fn_voca  =sys.argv[1]
fn_states  =sys.argv[2]
fn_prueba = sys.argv[4]

if not os.path.isfile(fn_corpus):
        print "Error con el archivo:", fn_corpus
        usage()
        exit(1)

# Program principal


corpus=[]

obs=set()
ocu=set()

voca=[]
states=[]
for line in open(fn_voca):
    line=line.strip()
    voca.append(line)

for line in open(fn_states):
    line=line.strip()
    states.append(line)

sup_=False
for line in open(fn_corpus):
    line=line.strip()
    bits=line.split("@@")
    wrds=bits[0].strip().split()
    for wrd in wrds:
        obs.add(wrd)
    if len(bits) == 1:
        tgs=[None for i in range(len(wrds))]
    else:
        tgs=bits[1].strip().split()
        sup_=True
        for tg in tgs:
            ocu.add(tg)
    elocucion=zip(wrds,tgs)
    corpus.append(elocucion)

hmmtrainer=HiddenMarkovModelTrainer(states,voca)

if sup_:
    print >> sys.stderr, "Entrenando supervisado"
    hmm=hmmtrainer.train(corpus,None)
else:
    print >> sys.stderr, "Entrenando sin supervision"
    hmm=hmmtrainer.train(None,corpus)

sntcs=[]

for line in open(fn_prueba):
    line=line.strip()
    bits=line.split('@@')

    sntcs.append(zip(bits[0].strip().split(),bits[1].strip().split()))

hmm.test(sntcs,verbose=True)

